select
  an.numero
  , count(distinct ma.data) as dias_tratamento
  , min(ma.data) as inicio_tratamento
  , max(ma.data) as fim_tratamento
  , g1.descricao as grupo_inicio_tratamento
  , pr1.nome as produto_1
  , pr2.nome as produto_2
  , pr3.nome as produto_3
from
  animal an
  join mamite ma on ma.cdanimal = an.cdanimal
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = an.cdanimal and re.dtmovimentacao <= ma.data order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  join tratamentobase tb on tb.cdtratamentobase = ma.cdtratamentobase
  left join produto pr1 on pr1.cdproduto = tb.cdproduto1
  left join produto pr2 on pr2.cdproduto = tb.cdproduto2
  left join produto pr3 on pr3.cdproduto = tb.cdproduto3
where
  ma.cdtratamentobase is not null
 --- INSIRA O PERÍODO DE MASTITE ABAIXO. MANTENHA O FORMATO 'AAAA-MM-DD.
  and ma.data between '2014-01-01' and '2014-09-12'
group by
  an.numero, an.numordenado, ma.cdtratamentobase, g1.descricao, pr1.nome, pr2.nome, pr3.nome
order by
  an.numordenado
